/**
 * \file DeviceDefine.h
 *
 * \brief  ض
 *  ͨģ飬ָͨӦд豸ԼͨͶӦҪĽʶ
 * \
 */

#ifndef _DEVICE_DEFINE_H_
#define _DEVICE_DEFINE_H_
#include <iostream>

namespace SCPICOMM
{
    /*ȡ*/
    enum DEV_TYPE
    {
        DT_SERIAL = 0,			        //	PMʼơʷǡZDL7000DX2048P
        DT_SAMPLE,				        //	PMʼƲ
    };



    /*Code(ṹ)*/
    enum CONFIG_CODE
    {	
        CONFIG_TIMEOUT = 0,				//	ӳʱ
        CONFIG_InOfStr,					//	ָ
        CONFIG_OutOfStr					//	ָ
    };


    /*̫ͨŲ*/
    struct LanCommArg
    {
        std::string		ip;				//	IPַ
        unsigned int port;				//	˿ں
    };


    /*GPIBͨŲ*/ 
    enum GPIB_TIME_OUT
    {
        TIME_TNONE = 0,                 //  Infinite timeout (disabled) 
        TIME_T10us,                     //  Timeout of 10 us (ideal)         
        TIME_T30us,                     //  Timeout of 30 us (ideal)            
        TIME_T100us,                    //  Timeout of 100 us (ideal)          
        TIME_T300us,                    //  Timeout of 300 us (ideal)          
        TIME_T1ms,                      //  Timeout of 1 ms (ideal)            
        TIME_T3ms,                      //  Timeout of 3 ms (ideal)            
        TIME_T10ms,                     //  Timeout of 10 ms (ideal)         
        TIME_T30ms,                     //  Timeout of 30 ms (ideal)           
        TIME_T100ms,                    //  Timeout of 100 ms (ideal)         
        TIME_T300ms,                    //  Timeout of 300 ms (ideal)          
        TIME_T1s,                       //  Timeout of 1 s (ideal)             
        TIME_T3s,                       //  Timeout of 3 s (ideal)             
        TIME_T10s,                      //  Timeout of 10 s (ideal)            
        TIME_T30s,                      //  Timeout of 30 s (ideal)             
        TIME_T100s,                     //  Timeout of 100 s (ideal)            
        TIME_T300s,                     //  Timeout of 300 s (ideal)            
        TIME_T1000s,                    //  Timeout of 1000 s (ideal)           
    };

    struct GpibCommArg
    {
        unsigned int    boardIndex;		//	忨ӿ(˿ð忨ӿ0~N)
        unsigned int    primaryAddr;	//	ַ(ӻ0~N)
        unsigned int    secondAddr;		//	εַ(0~N,һĬΪ0)
        GPIB_TIME_OUT   timeOut;	    //	ӳʱ(һ޿ΪTIME_T10s)
        unsigned int    eot;		    //	EOTЧ (0/1)(һĬΪ1)
        unsigned int    eos;			//	EOSЧ (0/1)(һĬΪ0)
    };

    /*RS232ͨŲ*/

    /*طʽ*/
    enum RS232_CONTROL
    {
        RS232_DEFAULT = 0,			    //	ĬϷʽ
        RS232_RTS,					    //	Ӳ
        RS232_DTR,						//		
        RS232_NO_C,						//	(һĬ)
    };

    struct RS232CommArg
    {
        unsigned int   comNum;			//	COMں(˿ôں)
        unsigned long  baudRate;	    //	(ӻ豸һ)
        unsigned char  byteSize;	    //	λ(4-8)
        unsigned char  parity;			//	Уλ(ʱ 0~4 ֱ None,Odd,Even,Mark,Space)
        unsigned char  stopBits;		//	ֹͣλ(ʱ 0,1,2 ֱ 1, 1.5, 2)
        RS232_CONTROL  ctrl;			//	طʽ
    };

    /*ͨӷʽ*/
    enum CONNECT_COMM
    {
        LAN_COMM  = 0,					//	̫
        GPIB_COMM,						//	GPIB
        RS232_COMM,						//	RS232
        USB_COMM,						//	USBͨ
    };

    /*Code*/
    enum ErrorCode
    {
        EC_SUCCESS = 0,					//	ɹ
        EC_FAILURE,						//	δ֪
        EC_NET_ERR,						//	ӳ
        EC_INSUFFICIENT_BUFFER_ERROR,	//	ڴ滺岻
        EC_NET_TIME_OUT,				//	糬ʱ
        EC_OBJECT_ERROR,				//	󲻴
        EC_INVILAD_PARAM				//	
    };
}



#endif		//	_DEVICE_DEFINE_H_