
/**
* @file    Interface.h
* @brief:    SCPIͨͨýӿ
* @details:  ֧̫GPIBRS232ͨ
* @date:     2013-12-6 
* @note:     ˽ӿڲӦ豸ķָĽʶԶӣ
             ҪûԼֶӦ豸ҪĽʶ 
*/

#pragma once

#if defined _DLL_EXPORT
#define DLL_EXPORT extern "C" __declspec(dllexport)
#else
#define DLL_EXPORT extern "C" __declspec(dllimport)
#endif

#include "TypeDefine.h"
#include "DeviceDefine.h"

typedef struct _SCPIInterface
{
	/**
	* @brief:   		
	* @return:  		ز				 NULLʧ
	*/
	typedef HANDLE (__stdcall*CREATEOBJECT)();
	CREATEOBJECT CreateObject;

	/**
	* @brief:   		
	* @param[in]:		HANDLE handle				CreateObjectصĲ
	* @param[in]:		CONNECT_COMM type			:LAN_COMM  GPIB_COMM RS232_COMM
	* @param[in]:		void * arg					INETLanCommArg
													GPIBGpibCommArg
													RS232:RS232CommArg
	* @return:			EC_OBJECT_ERROR		δɹ
						EC_NET_ERR:				Ӵ
						EC_SUCCESS:				ӳɹ
	*/
	typedef int (__stdcall*OPEN)(IN HANDLE handle, IN SCPICOMM::CONNECT_COMM type, IN void * arg);  
	OPEN Open;

	/**
	* @brief:   		ر
	* @param[in]:		HANDLE handle				CreateObjectصĲ 
	* @return:  		EC_OBJECT_ERROR		δɹ
						EC_SUCCESS:				رճɹ
	*/
	typedef int (__stdcall*CLOSE)(IN HANDLE handle);
	CLOSE Close;

	/**
	* @brief:   		Ӳ(Ԥ)
	* @detail:			ӳʱ
	* @param[in]:		HANDLE handle				CreateObjectصĲ
	* @param[in]:		CONFIG_CODE code			Code
	* @param[in]:		const char* val				ò:ʾ:"10"
	* @param[in]:		int len						ò
	* @return:  		EC_OBJECT_ERROR		δɹ
						EC_FAILURE:				ʧ
	*/
	typedef int (__stdcall*CONFIG)(IN HANDLE handle, IN SCPICOMM::CONFIG_CODE code, IN const char* val, IN int len);
	CONFIG Config;

	/**
	* @brief:   		ָӦ
	* @param[in]:		HANDLE handle				CreateObjectصĲ
	* @param[in]:		const char* command			ָ
	* @param[in]:		const int cmdSize			ָС
	* @param[in]:		bool resFlag				ǷӦ
	* @param[in/out]:	char* response				Ӧ
	* @param[in/out]:	int* size					Ӧ
	* @param[in]:		DEV_TYPE devType			ȡ
	* @return:  		EC_OBJECT_ERROR		δɹ
						EC_NET_ERR			ӳ
						EC_FAILURE:				ʧ
						EC_INSUFFICIENT_BUFFER_ERROR:Ӧ
						EC_SUCCESS:				ճɹ
	*/
	typedef int (__stdcall*SENDANDGETRESPONSE)(IN HANDLE handle, IN const char* command, IN const int cmdSize, IN bool resFlag, OUT char* response, OUT int* size, IN SCPICOMM::DEV_TYPE devType);
	SENDANDGETRESPONSE SendAndGetResponse;

	/**
	* @brief:   		ͷŲԴ
	* @param[in]:		HANDLE handle				CreateObjectصĲ	
	*/
	typedef void (__stdcall*RELEASE)(IN HANDLE handle);
	RELEASE Release;

	/**
	* @brief:   		ȡǰ汾
	* @param[in]:		HANDLE handle				CreateObjectصĲ
	* @param[in/out]:	char* versionStr			汾Ż
	* @param[in/out]:	int* size					汾Ż
	* @return:  		EC_OBJECT_ERROR:		δɹ
						EC_INSUFFICIENT_BUFFER_ERROR:
						EC_SUCCESS:				ȡɹ
	*/
	typedef int (__stdcall*GETVERSION)(IN HANDLE handle, IN OUT char* versionStr,  IN OUT  int* size);
	GETVERSION GetDLLVersion;

}SCPIInterface;

// DLL Ľӿں
// IN OUT SCPIInterface **pInterface
DLL_EXPORT BOOL  GetInterface(IN OUT SCPIInterface **pInterface);
