
// SCPI_TESTDlg.h : ͷļ
//

#pragma once

#include "afxcmn.h"
#include "afxwin.h"

#include <iostream>
#include <map>
#include <set>


#include "DeviceDefine.h"
#include "TypeDefine.h"

#include "Interface.h"

//#include "PA6000Common.h"
//#include "PA6000Interface.h"

// CSCPI_TESTDlg Ի
class CSCPI_TESTDlg : public CDialog
{
// 
public:
	CSCPI_TESTDlg(CWnd* pParent = NULL);	// ׼캯
	
	~CSCPI_TESTDlg();

// Ի
	enum { IDD = IDD_SCPI_TEST_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ֧


	void InitCtrl();

	void LoadDll();

// ʵ
public:

	HICON                   m_hIcon;

	SCPIInterface			*m_pScpi;
	
	HANDLE					m_scpiHandle;

	HMODULE					m_hModule;

	CIPAddressCtrl			m_ipAddress;
		
	CString					m_sendString;
	
	CString					m_recvString;
	
	SCPICOMM::CONNECT_COMM  m_connectType;

	UINT					m_getdataLen;

	HANDLE					m_threadHandle;

	CComboBox				m_comNum;

	CComboBox				m_boaudRate;

	CComboBox				m_byteSize;

	CComboBox				m_parity;

	CComboBox				m_stopBits;

	UINT					m_ipPort;

	CComboBox				m_gpibBoard;

	CComboBox				m_gpibPriAddr;

	CComboBox				m_gpibSecAddr;

	CComboBox				m_gpibTimeout;

	CComboBox				m_gpibEot;

	CComboBox				m_gpibEos;
	
	BOOL					m_sendCommand;
	
	CComboBox				m_devTypeComm;

	// ɵϢӳ亯
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
    afx_msg void OnClose();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

	void SetConnectBtnState(UINT nID);

	void SetBtnIPState(BOOL flag);

	void SetBtnGPIBState(BOOL flag);

	void SetBtnRS232State(BOOL flag);

	void SetBtnUSBState(BOOL flag);

    void SetBntStates(BOOL flag);

	/**
	* @brief:   	̺߳ 
	*/
	static DWORD WINAPI	 GetDataThread(void *pParam);

	LRESULT SetState(WPARAM wParam, LPARAM lParam);

public:

	afx_msg void OnBnClickedIp();

	afx_msg void OnBnClickedGpib();
	
	afx_msg void OnBnClickedRS232();

	afx_msg void OnBnClickedUSB();

	afx_msg void OnBnClickedCancel();

	afx_msg void OnBnClickedConnect();

	afx_msg void OnBnClickedSend();

	afx_msg void OnBnClickedCloseconnect();
	
	afx_msg void OnBnClickedClearMsg();

};
